putlog "vtipy.tcl 1.0 start load"

#############################################################
# !vtip .......... vybere nahodny vtip ze souboru vtipy.txt #
#                  napsat se muze i konkretni *slovo*       #
# !vtips ......... kolik vtipu je v databazi                #
# !addvtip ....... prida novy vtip do vtipy.txt nebo *.new  #
#############################################################

#kanalovy prikaz pro vypsani vtipu 
bind pub -|- "!vtip" vtip

#kanalovy prikaz pro vypsani poctu vtipu
bind pub -|- "!vtips" vtipnum

#kanalovy prikaz pro vlozeni vtipu uzivateli
bind pub -|- "!addvtip" tgvtipnew

#databaze vtipu - posledni radku odentrovat (prazdna radka na konci)
set tgvtip "/windrop1.6.19-handlen32/SCRIPTS/vtipy.txt"

#Nove vtipy se mohou ukladat do vtipy.new a po schvaleni rucne prepsat
#do databaze vtipu (0), nebo rovnou do databaze vtipu (1)
set tgvtipvolba 1

#Pokud jste vyse nastavili (0), napiste cestu do databaze pridanych 
#vtipu uzivateli ke schvaleni.
set tgvtipdb "/windrop1.6.19-handlen32/SCRIPTS/vtipy.new"

#Chcete vypisovat info o vlozenem vtipu na nejaky kanal, nebo nechte jen ""
set chaninfo "#hrosik"

# 0 = zobratiz basnicku na kanale
# 1 = zobratiz basnicku via notice.
set quotevianotice 0

### samotny skript - nize uz nic nemente, pokud si nejste jisti
proc vtip {nick host hand chan arg} {
 global tgvtip tgvtippocet tgvtiplist quotefile quotevianotice
 set quotes ""
 if { [file exists $tgvtip] } { set file [open $tgvtip r]} 
 while { ![eof $file] } {
  set quote [gets $file]
  if { $quote != "" } {
   set quotes [linsert $quotes end $quote]
  }
 }
 close $file
 if { $arg != "" } {
  set pattern [string tolower $arg]
  set aquotes ""
  set quote ""
  foreach quote $quotes {
   set lowquote [string tolower $quote]
   if { [string match $pattern $lowquote] } {
    set aquotes [linsert $aquotes end $quote]
   }
   set quotes ""
   set quotes $aquotes
  }
 }
 set row [rand [llength $quotes]]
 if { [expr $row >= 0] && [expr $row < [llength $quotes]] } {
  set quote [lindex $quotes $row]
 }
 if { $quote != "" } {
  if { $quotevianotice == 0 } {
   putmsg $chan "$quote"
  }
  if { $quotevianotice == 1 } {
   putnotc $nick "$quote"
  }
 }
 return 1
}

proc vtipnum {nick host hand chan rest} {
global tgvtip tgvtippocet tgvtiplist
 set tgvtippocet 0
 set tgvtiplist ""
 set file [open $tgvtip r]
 while {![eof $file]} {
  lappend tgvtiplist [gets $file]
  incr tgvtippocet 
   }
 close $file
set tgvtippocetx [expr $tgvtippocet-1]
putserv "PRIVMSG $chan :v databazi je $tgvtippocetx vtipu"
}

proc tgvtipnew {nick host hand chan text} {
 global tgvtippocet tgvtipdb chaninfo tgvtip tgvtipvolba  
 set _desc $text
 if {$_desc==""} {
  putserv "NOTICE $nick :nenapsal jsi zadny vtip"
  } else {
 if {$tgvtipvolba==0} {
  set _file [open $tgvtipdb a]
  puts $_file ""
  puts $_file "Dne: [strftime %A,\ %d\ %B\ %Y\ @\ %H:%M:%S]"
  puts $_file "Vlozil:\t$nick!$host"
  puts $_file "Vtip:\t$_desc"
  puts $_file "------------------------------"
  close $_file
  putserv "NOTICE $nick :Diky! Vtip byl ulozen a odeslan k odsouhlaseni."
   }
if {$tgvtipvolba==1} {
  set _file [open $tgvtip a]
  puts $_file "$_desc (c)$nick"
  close $_file
  putserv "NOTICE $nick :Diky! Vtip byl ulozen."
   }
 putserv "PRIVMSG $chaninfo :int004: $nick ($host) vlozil novy vtip do databaze -> $text"
 }
}

putlog "vtipy.tcl 1.0 by Hrosik-85- loaded"